// The below imported trait/extension is for adding a `from_str` method which will let us convert
// strings to other types
use std::env;
use std::str::FromStr;

fn gcd(mut a: u64, mut b: u64) -> u64 {
    while a > 0 {
        if a < b {
            let temp = b;
            b = a;
            a = temp;
        }

        a = a % b
    }
    b
}

#[test]
fn test_gcd() {
    assert_eq!(gcd(3, 7), 1);
    assert_eq!(gcd(16, 128), 16);
}

fn main() {
    let mut numbers = Vec::new();

    for arg in env::args().skip(1) {
        numbers.push(u64::from_str(&arg).expect("error parsing argument"));
    }

    if numbers.len() == 0 {
        eprintln!("Usage: gcd NUMBER ...");
        std::process::exit(1);
    }

    let mut result = numbers[0];

    for num in &numbers[1..] {
        result = gcd(*num, result);
    }

    println!("The greatest common divisor of {:?} is {}", numbers, result);
}
